/*---------------------------------------------------------------------
tHƑwHw{eBNXw
[1S] ̌K

AKI-3694tbg}CRLbg
H8 Tiny I/O BOARD

HLCD 
SC1602쓮eXgvO

 * pinڑ
 * LCD P1  Vcc --- 5.0V
 * LCD P2  GND --- GND
 * LCD P3  Vo ---- 2.5V
 * LCD P4  RS ---- P12
 * LCD P5  RW ---- P11
 * LCD P6  E ----- P10
 * LCD P7  D0 ---- NC
 * LCD P8  D1 ---- NC
 * LCD P9  D2 ---- NC
 * LCD P10 D3 ---- NC
 * LCD P11 D4 ---- P50
 * LCD P12 D5 ---- P51
 * LCD P13 D6 ---- P52
 * LCD P14 D7 ---- P53

written by U@fuRo,2009
- ----------------------------------------------------------------------*/

#include <3694.h>       // H8 Tiny̓I/O`
#include <stdlib.h>     // itoa֐p
#include <stdio.h>     // itoa֐p

// Mpobt@(͋CɂȂ)
char txb[10], rxb[10];


#define setE()  IO.PDR1.BIT.B0=1
#define clrE()  IO.PDR1.BIT.B0=0
#define cmd_mode()  IO.PDR1.BIT.B2=0    // RS = 0 R}h[h
#define data_mode() IO.PDR1.BIT.B2=1    // RS = 1 f[^[h
#define setD(x) IO.PDR5.BYTE = 0xff&x
#define lcd_CLR() cmd_mode();send(0x01);ms_wait(1)
#define lcd_HOME() cmd_mode();send(0x02);ms_wait(1)
#define lcd_LF() cmd_mode();send(0xc0);ms_wait(1)
#define lcd_SEND(x) data_mode();send(x)


void InitH8(void)
{
  //-----------------------
  // ^C}Vݒ (ŏ\1msEFCgp)
  //-----------------------
  TV.TCRV0.BIT.CCLR = 1;      // RyA}b`ATCNVNA
  TV.TCRV0.BIT.CKS  = 0;      // ~
  TV.TCRV1.BIT.ICKS = 1;      // LCKS=3ƕp /128=125kHz
  TV.TCSRV.BIT.CMFA = 0;      // tONA
  TV.TCNTV          = 0;      // ^C}JE^NA
  TV.TCORA          = 125-1;  // ^CRX^gWX^Aݒ 125kHz/125=1ms

    IO.PCR5=0x0f;   //|[g50,1,2,3rbg͏o(ݒl1)ɐݒ
   IO.PCR1=0x0f;   //|[g10,1,2,3rbg͏o(ݒl1)ɐݒ
   IO.PCR8=0x03;   //|[g80,1rbg͏o(ݒl1)ɐݒ
 
  //-----------------------
  // ʐM|[g
  //-----------------------
  SCI3_INIT (br57600, txb, sizeof(txb), rxb, sizeof(rxb));
}
/*-----------------------------------------------*/
/* 1msEFCg                                   */
/*-----------------------------------------------*/


void ms_wait (long num)
{
  long i;

  TV.TCRV0.BIT.CKS  = 3;          // JEgJn
  for (i = 0; i < num; i++) {
    while (!TV.TCSRV.BIT.CMFA) ;  // TCNTV=TCORAtO҂
    TV.TCSRV.BIT.CMFA = 0;        // tONA
  }
  TV.TCRV0.BIT.CKS = 0;           // JEg~
}

// 4bit
void send4bit(unsigned char c)
{
    setE();
    setD(c);
    clrE();
}

// 8bit
void send(unsigned char c)
{
    send4bit(c >> 4);
    send4bit(c);
    ms_wait(1);
}

// LCD
void lcd_INIT(void)
{
    cmd_mode();
    clrE();

    ms_wait(100);      // 15ms҂
    send4bit(3);       // function set 8bit mode
    ms_wait(5);        // 4.1msȏ҂
    send4bit(3);       // function set 8bit mode
    ms_wait(1);        // 100usȏ҂
    send4bit(3);       // function set 8bit mode
    ms_wait(1);        // 40usȏ҂
    send4bit(2);       // function set 4bit mode
    ms_wait(1);        // 40usȏ҂
    send(0x08);        // display off
    send(0x28);        // function set 4bit 2line
    send(0x06);        // entry mode
    send(0x01);        // display clear (1.64ms)
    ms_wait(1);
    send(0x02);        // cursor at home (1.64ms)
    ms_wait(1);
    send(0x0c);        // display on
}

// C[`
void main( void )
{
    static const char msg[] = "Hello!!World(^o^)/?";
    int i;

    
  InitH8 ();
  EI;
 

    // LCD
    lcd_INIT();
    
 while(1)
    {    
   lcd_CLR();//LCDNA
   lcd_HOME();//J[\z[
   
    // bZ[Wo
    for(i = 0; msg[i] != '\0'; i++){
        if(i == 16){
    lcd_LF(); //s
        }
        lcd_SEND(msg[i]);
        ms_wait(500);
    }

    
    
    // LED߰ 
    IO.PDR8.BIT.B0 = 0;

    // _
    for(i=0;i<10;i++){
        ms_wait(100);
    IO.PDR8.BIT.B0 ^= 1;   
    }
    
    }
}
